%global __requires_exclude ^perl\\(File::Spec\\)\s*$
%global __provides_exclude ^perl\\(DynaLoader|ExtUtils::MakeMaker::_version\\)

Summary:        Create a module Makefile
Name:           perl-ExtUtils-MakeMaker
Version:        7.70
Release:        2%{?dist}
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/ExtUtils-MakeMaker
Source0:        https://cpan.metacpan.org/authors/id/B/BI/BINGOS/ExtUtils-MakeMaker-%{version}.tar.gz

Patch3000:      ExtUtils-MakeMaker-7.36-USE_MM_LD_RUN_PATH.patch
Patch3001:      ExtUtils-MakeMaker-7.30-Link-to-libperl-explicitly-on-Linux.patch
Patch3002:      ExtUtils-MakeMaker-7.04-Unbundle-version.patch
Patch3003:      ExtUtils-MakeMaker-7.22-Unbundle-Encode-Locale.patch
Patch3004:      ExtUtils-MakeMaker-7.11-Provide-ExtUtils-MM-methods-as-standalone-ExtUtils-M.patch

BuildRequires:  coreutils make perl-generators perl-interpreter
BuildRequires:  perl(Carp) perl(Config) perl(Cwd) perl(Encode) perl(Exporter)
BuildRequires:  perl(File::Basename) perl(File::Copy) perl(File::Path) perl(lib)
BuildRequires:  perl(strict) perl(vars) perl(version) perl(warnings) perl(base)
BuildRequires:  perl-ExtUtils-ParseXS perl(AutoSplit) perl(Data::Dumper) perl(B)
BuildRequires:  perl(DynaLoader) perl(File::Find) perl(Getopt::Long) perl(less)
BuildRequires:  perl(overload) perl(Pod::Man) perl(POSIX) perl(subs) perl(utf8)
BuildRequires:  perl-devel perl(ExtUtils::CBuilder) perl(PerlIO)
BuildRequires:  perl(File::Spec) >= 0.8
BuildRequires:  perl(CPAN::Meta) >= 2.143240
BuildRequires:  perl(ExtUtils::Install) >= 1.52
BuildRequires:  perl(ExtUtils::Manifest) >= 1.70
BuildRequires:  perl(File::Temp) >= 0.22
BuildRequires:  perl(Parse::CPAN::Meta) >= 1.4414
BuildRequires:  perl(Test::Harness) perl(Test::More) perl(Text::ParseWords)
Requires:       perl(B) perl(Data::Dumper) perl(DynaLoader) perl(Encode)
Requires:       perl(ExtUtils::Command) >= 1.19
Requires:       perl(ExtUtils::Install) >= 1.54
Requires:       perl(ExtUtils::Manifest) >= 1.70
Requires:       perl(File::Spec) >= 0.8
Requires:       perl(File::Find) perl(Getopt::Long) perl(Pod::Man)
Requires:       perl(POSIX) perl-ExtUtils-ParseXS
Requires:       perl(Test::Harness) perl(Text::ParseWords)
Recommends:     perl-devel gcc
Recommends:     perl(Time::HiRes)
Recommends:     perl(CPAN::Meta) >= 2.143240
Recommends:     perl(CPAN::Meta::Requirements) >= 2.130
%if ! 0%{?perl_bootstrap}
Recommends:     perl(Encode::Locale)
%endif
Suggests:       perl(JSON::PP)
Suggests:       perl(CPAN::Meta::Converter) >= 2.141170
BuildArch:      noarch

%description
This utility is designed to write a Makefile for an extension module from a
Makefile.PL. It is based on the Makefile.SH model provided by Andy Dougherty 
and the perl5-porters.

%package -n perl-ExtUtils-Command
Summary:        Utilities to replace common UNIX commands in Makefiles etc.
License:        GPL+ or Artistic
Requires:       perl(Carp) perl(File::Copy) perl(File::Find) perl(File::Path)
BuildArch:      noarch

%description -n perl-ExtUtils-Command
The module is used to replace common UNIX commands. In all cases the functions 
work from @ARGV rather than taking arguments. This makes them easier to deal 
with in Makefiles.

%package -n perl-ExtUtils-MM-Utils
Summary:        ExtUtils::MM methods without dependency on ExtUtils::MakeMaker
License:        GPL+ or Artistic
BuildArch:      noarch

%description -n perl-ExtUtils-MM-Utils
This is a collection of ExtUtils::MM subroutines that are used by many other 
modules but that do not need full-featured ExtUtils::MakeMaker. The issue with 
ExtUtils::MakeMaker is it pulls in Perl header files and that is an overkill 
for small subroutines.

%prep
%autosetup -n ExtUtils-MakeMaker-%{version} -p1

rm -rf bundled t/lib/Test \
	   lib/ExtUtils/MakeMaker/version{,.pm} \
	   lib/ExtUtils/MakeMaker/Locale.pm
sed -i '/^bundled/d 
		/^t\/lib\/Test\//d
		/^lib\/ExtUtils\/MakeMaker\/version.*\.pm/d
		/^lib\/ExtUtils\/MakeMaker\/Locale\.pm/d' MANIFEST

%build
BUILDING_AS_PACKAGE=1 perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} -c %{buildroot}

%check
export HARNESS_OPTIONS=j%{_smp_build_ncpus}
make test

%files
%doc Changes CONTRIBUTING README
%{perl_vendorlib}/*
%exclude %{perl_vendorlib}/ExtUtils/Command.pm
%exclude %dir %{perl_vendorlib}/ExtUtils/MM
%exclude %{perl_vendorlib}/ExtUtils/MM/Utils.pm
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man3/*
%exclude %{_mandir}/man3/ExtUtils::Command.*
%exclude %{_mandir}/man3/ExtUtils::MM::Utils.*

%files -n perl-ExtUtils-Command
%dir %{perl_vendorlib}/ExtUtils
%{perl_vendorlib}/ExtUtils/Command.pm
%{_mandir}/man3/ExtUtils::Command.*

%files -n perl-ExtUtils-MM-Utils
%dir %{perl_vendorlib}/ExtUtils
%dir %{perl_vendorlib}/ExtUtils/MM
%{perl_vendorlib}/ExtUtils/MM/Utils.pm
%{_mandir}/man3/ExtUtils::MM::Utils.*

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.70-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Jul 31 2023 Xiaojie Chen <jackxjchen@tencent.com> - 7.70-1
- Upgrade to upstream version 7.70
- Remove perl(MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.64-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.64-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Aug 10 2022 Xiaojie Chen <jackxjchen@tencent.com> - 7.64-1
- Initial build
